/*  Bill Rouady
    Netscape Communications, Inc.
    April, 1996
	Update to new API: May/June 1996
*/

import java.applet.Applet;
import java.awt.*;
import java.applet.AudioClip;
import l3d.*;
import netscape.javascript.JSObject;



/**

    jugglershow applet:  Class Definition
        Applet which runs the JugglerShow demo

*/

public class jugglershow extends Applet implements Runnable {

	JSObject document;
	L3DScene l3d;

    L3DObject nJugglerLogo;
    L3DObject nJuggler;
    L3DObject nText1;
    L3DObject nText2;
    L3DObject nText3;
    L3DObject nText4;
    L3DObject nText5;
    L3DObject nText6;
    L3DObject nText7;
    L3DObject nText8;
    L3DObject nBall1;
    L3DObject nBall2;
    L3DObject nBall3;
    L3DObject nBall4;

    boolean buttonHold = true;  // Disable buttons for rotation
    Button restartButton = new Button("Back");
    Label Text = new Label("Juggler Toys", Label.CENTER);

    AudioClip music;
    AudioClip woosh;
    AudioClip chot;
    AudioClip brasso;
    AudioClip applaus;
    AudioClip timpani;

    Thread jugglerThread;


/*
    jugglershow applet:  init method
*/

    public void init() {

	// Main Initialization
   		document = getDocument();
        System.out.println("Got This Far again" + document);
		l3d = (L3DScene)document.getMember("l3d");
        System.out.println("Got This Far 3" + l3d);

    // Applet Display

        setLayout(new GridLayout(1,1));
        setBackground(new Color(255, 255, 204));
        Text.setFont(new Font("Helvetica", Font.ITALIC, 12));
        add(Text);

    // Get All necessary object ID's

        while(nJugglerLogo==null) {
	        nJugglerLogo = l3d.getObject("JuggLogo");
	        System.out.println("JugglerLogo ID acquired");
		}

        nText1 = l3d.getObject("ClassicsText");
        System.out.println("Text1 ID acquired");

        nText2 = l3d.getObject("FamilyText");
        System.out.println("Text2 ID acquired");

        nText3 = l3d.getObject("SuperText");
        System.out.println("Text3 ID acquired");

        nText4 = l3d.getObject("QualityText");
        System.out.println("Text4 ID acquired");

        nText5 = l3d.getObject("ValueText");
        System.out.println("Text5 ID acquired");

        nText6 = l3d.getObject("DurableText");
        System.out.println("Text6 ID acquired");

        nText7 = l3d.getObject("TodayText");
        System.out.println("Text7 ID acquired");

        nText8 = l3d.getObject("TomorrowText");
        System.out.println("Text8 ID acquired");

        nJuggler = l3d.getObject("Juggler");
        System.out.println("Juggler ID acquired");

        nBall1 = l3d.getObject("JuggBall01");
        System.out.println("Ball1 ID acquired");

        nBall2 = l3d.getObject("JuggBall02");
        System.out.println("Ball2 ID acquired");

        nBall3 = l3d.getObject("JuggBall03");
        System.out.println("Ball3 ID acquired");

        nBall4 = l3d.getObject("JuggBall04");
        System.out.println("Ball4 ID acquired");


        music = getAudioClip(getDocumentBase(), "icp.au");
        woosh = getAudioClip(getDocumentBase(), "slice.au");
        applaus = getAudioClip(getDocumentBase(), "applaus.au");
        brasso = getAudioClip(getDocumentBase(), "brasso.au");
        chot = getAudioClip(getDocumentBase(), "chot.au");
        timpani = getAudioClip(getDocumentBase(), "timpini.au");
    }

/*
    jugglershow applet:  start method
*/

    public void start() {

    	jugglerThread = new Thread(this);
    	jugglerThread.start();

    }

/*
    jugglershow applet:  run method
*/

    public void run() {

//        music.loop();

//    	try {Thread.currentThread().sleep(5000);} catch (InterruptedException e){}
//        Text.setText("");

    // Camera Dolly Out

        float fXPos = 0.0f;
        float fYPos = -22.0f;
        float fZPos = -0.5f;
        float fXLookAt = 0.0f;
        float fYLookAt = 1.0f;
        float fZLookAt = 0.0f;
        float fXLookUp = 0.0f;
        float fYLookUp = 0.0f;
        float fZLookUp = 1.0f;

        l3d.setCameraView(fXPos, fYPos, fZPos,
                          fXLookAt, fYLookAt, fZLookAt,
                          fXLookUp, fYLookUp, fZLookUp);

		l3d.render();
//        music.stop();
        timpani.play();

     // Rotate Logo into Position
        for(float ff=0; ff<1.4; ff += 0.1f) {
			nJugglerLogo.rotate(0.1f, 0.0f, 0.0f, 1, 1);
        	l3d.render();
        }

     // Do a juggle
        juggleTime();

       	try {Thread.currentThread().sleep(2200);} catch (InterruptedException e){}

        juggleTime();

       	try {Thread.currentThread().sleep(2200);} catch (InterruptedException e){}

        music.loop();

// Repeating function for after show

        while (jugglerThread != null) {

            runShow();
            juggleTime();
        	try {Thread.currentThread().sleep(500);} catch (InterruptedException e){}

        }

    }

/*
    jugglershow applet:  stop method
*/

    public void stop() {

        music.stop();
        jugglerThread.stop();

    }


/*
    jugglershow applet: destroy method
*/

    public void destroy() {

    }



/*
* jugglershow applet:  juggleTime method
*  causes juggler to juggle his balls
**/

    public void juggleTime() {

        nBall1.setTransparency(0.0f);
        l3d.render();
    	try {Thread.currentThread().sleep(250);} catch (InterruptedException e){}

        nBall1.setTransparency(1.0f);
        nBall2.setTransparency(0.0f);
        l3d.render();
    	try {Thread.currentThread().sleep(250);} catch (InterruptedException e){}

        nBall2.setTransparency(1.0f);
        nBall3.setTransparency(0.0f);
        l3d.render();
    	try {Thread.currentThread().sleep(250);} catch (InterruptedException e){}

        nBall3.setTransparency(1.0f);
        nBall4.setTransparency(0.0f);
        l3d.render();
    	try {Thread.currentThread().sleep(250);} catch (InterruptedException e){}

		nBall4.setTransparency(1.0f);
        l3d.render();
    	try {Thread.currentThread().sleep(250);} catch (InterruptedException e){}

    }

/*
*  jugglershow applet: runShow() method
*   this is the main portion of the show
*/
    public void runShow() {

    // Transparent Logo to 50 percent

        float fX;
        float fZ;

        nJugglerLogo.setTransparency(0.5f) ;
        l3d.render();

     // First Text Parade

        nText1.translate(30.0f, 0.0f, 0.0f, 2, 0);
        nText2.translate(-30.0f, 0.0f, 0.0f, 2, 0);
        nText3.translate(30.0f, 0.0f, 0.0f, 2, 0);
		l3d.render();

        woosh.play();

        nText1.setTransparency(0.0f);
        l3d.render();
        for(fX=30.0f; fX>=0.0f; fX-=5.0f) {
            nText1.translate(fX, 0.0f, 0.0f, 2, 0);
	        l3d.render();
        }
    	try {Thread.currentThread().sleep(500);} catch (InterruptedException e){}

        woosh.play();

        nText2.setTransparency(0.0f);
        l3d.render();
        for(fX=-30.0f; fX<=0.0f; fX+=5.0f) {
            nText2.translate(fX, 0.0f, 0.0f, 2, 0);
	        l3d.render();
        }
    	try {Thread.currentThread().sleep(500);} catch (InterruptedException e){}

        woosh.play();

        nText3.setTransparency(0.0f);
        l3d.render();
        for(fX=30.0f; fX>=0.0f; fX-=5.0f) {
            nText3.translate(fX, 0.0f, 0.0f, 2, 0);
	        l3d.render();
        }
    	try {Thread.currentThread().sleep(500);} catch (InterruptedException e){}

     // Quick Juggle
        juggleTime();
    	try {Thread.currentThread().sleep(500);} catch (InterruptedException e){}

     // First Text Parade Leaves
        woosh.play();

        for(fX=0.0f; fX>=-30.0f; fX-=5.0f) {
            nText1.translate(fX, 0.0f, 0.0f, 2, 0);
	        l3d.render();
        }
    	try {Thread.currentThread().sleep(500);} catch (InterruptedException e){}

        woosh.play();
        nText1.setTransparency(1.0f);
        l3d.render();

        for(fX=0.0f; fX<=30.0f; fX+=5.0f) {
            nText2.translate(fX, 0.0f, 0.0f, 2, 0);
	        l3d.render();
        }
    	try {Thread.currentThread().sleep(500);} catch (InterruptedException e){}

        woosh.play();
        nText2.setTransparency(1.0f);
        l3d.render();

        for(fX=0.0f; fX>=-30.0f; fX-=5.0f) {
            nText3.translate(fX, 0.0f, 0.0f, 2, 0);
	        l3d.render();
        }
    	try {Thread.currentThread().sleep(500);} catch (InterruptedException e){}
        nText3.setTransparency(1.0f);
        l3d.render();

    // Fade 2nd Text Parade In

        nText4.translate(0.0f, 0.0f, 0.0f, 2, 0);
        nText5.translate(0.0f, 0.0f, 0.0f, 2, 0);
        nText6.translate(0.0f, 0.0f, 0.0f, 2, 0);
        l3d.render();


        chot.play();

        for(float ff=1.0f;ff>=0.0f;ff-=.1f) {

            nText4.setTransparency(ff) ;
	        l3d.render();
        }
        nText4.setTransparency(0.0f) ;
        l3d.render();
    	try {Thread.currentThread().sleep(750);} catch (InterruptedException e){}

        chot.play();

        for(float ff=1.0f;ff>=0.0f;ff-=.1f) {

            nText5.setTransparency(ff) ;
	        l3d.render();
        }
        nText5.setTransparency(0.0f) ;
        l3d.render();
    	try {Thread.currentThread().sleep(750);} catch (InterruptedException e){}

        chot.play();

        for(float ff=1.0f;ff>=0.0f;ff-=.1f) {

            nText6.setTransparency(ff) ;
	        l3d.render();
        }
        nText6.setTransparency(0.0f) ;
        l3d.render();

        juggleTime();

    //  Pop out 2ndParade
        woosh.play();
        fX = 0.0f;
        fZ = 0.0f;
        for(float fY=0.0f; fY>=-30.0f; fY-=5.0f) {
            fX -= .2f;
            fZ -= .125f;
            nText4.translate(fX, fY, fZ, 2, 0);
	        l3d.render();
        }
        nText4.setTransparency(1.0f) ;
        l3d.render();
    	try {Thread.currentThread().sleep(750);} catch (InterruptedException e){}

        woosh.play();
        fX = 0.0f;
        fZ = 0.0f;
        for(float fY=0.0f; fY>=-30.0f; fY-=5.0f) {
            fX += .2f;
            fZ -= .125f;
            nText5.translate(fX, fY, fZ, 2, 0);
	        l3d.render();
        }
        nText5.setTransparency(1.0f) ;
        l3d.render();
    	try {Thread.currentThread().sleep(750);} catch (InterruptedException e){}

        woosh.play();
        fX = 0.0f;
        fZ = 0.0f;
        for(float fY=0.0f; fY>=-30.0f; fY-=5.0f) {
            fX -= 1.0f;
            fZ += 1.0f;
            nText6.translate(fX, fY, fZ, 2, 0);
	        l3d.render();
        }
        nText6.setTransparency(1.0f) ;
        l3d.render();

        juggleTime();

    // Appear and Scale in Today Text

        music.stop();
        brasso.play();

        nText7.scale(0.01f, 0.01f, 0.01f, 2, 1);
        nText7.setTransparency(0.0f);
        l3d.render();

        for(float ff=0.1f; ff<=1.0f; ff+=0.1f) {
            nText7.scale(ff, ff, ff, 2, 1);
	        l3d.render();
    		try {Thread.currentThread().sleep(100);} catch (InterruptedException e){}
        }
    	try {Thread.currentThread().sleep(1000);} catch (InterruptedException e){}

        nText8.setTransparency(0.0f);
        l3d.render();

        juggleTime();
    	try {Thread.currentThread().sleep(3000);} catch (InterruptedException e){}
        juggleTime();

    // Dissolve ColorCycling Text Out

        applaus.play();

        for(float ff=0.0f;ff<=1.0f;ff+=.1f) {

            nText7.setTransparency(ff) ;
            nText8.setTransparency(ff) ;
	        l3d.render();
        }
        nText7.setTransparency(1.0f) ;
        nText8.setTransparency(1.0f) ;
        l3d.render();

        juggleTime();

    // Transparent Logo back up to 100% opaque

        nJugglerLogo.setTransparency(0.0f) ;
        l3d.render();

    	try {Thread.currentThread().sleep(2500);} catch (InterruptedException e){}

        juggleTime();

    	try {Thread.currentThread().sleep(2000);} catch (InterruptedException e){}

    // Spin Juggler Logo


        for(int i=0; i<11; i++) {
            nJugglerLogo.rotate(0.2f, 0.0f, 0.0f, 1, 1);
	        l3d.render();
        }
        for(fZ=0.0f; fZ<=10.0f; fZ+=2.0f) {
            nJuggler.translate(0.0f, 0.0f, fZ, 2, 0);
	        l3d.render();
        }
        juggleTime();
        music.loop();
        for(int i=0; i<10; i++) {
            nJugglerLogo.rotate(0.2f, 0.0f, 0.0f, 1, 1);
	        l3d.render();
        }
        for(fZ=10.0f; fZ>=0.0f; fZ-=2.0f) {
            nJuggler.translate(0.0f, 0.0f, fZ, 2, 0);
	        l3d.render();
        }
        juggleTime();

        for(int i=0; i<10; i++) {
            nJugglerLogo.rotate(0.2f, 0.0f, 0.0f, 1, 1);
	        l3d.render();
        }

    // Rotation bug Correction
        nJugglerLogo.rotate(0.08f, 0.0f, 0.0f, 1, 1);
        l3d.render();

    }

	public JSObject getDocument() {
     System.out.println("Got This Far" + this);
		return (JSObject)JSObject.getWindow(this).getMember("document");
	}

}
